/* Copyright 2006 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef BOUNDINGBOX_HH
#define BOUNDINGBOX_HH

#include "Point.hh"

namespace SharpConstruct
{
	class BoundingBox
	{
	public:
		BoundingBox();

		void Initialize( const Point3D& );
		void Expand( const Point3D& );

		const Point3D& Center() const;
		float Diameter() const;
	private:
		void update_();

		// Points must be wrapped to avoid alignment problems
		Point3DVector points_;
		const static unsigned min_ = 0, max_ = 1, center_ = 2;
		float diameter_;
	};
}

#endif
