/* Copyright 2006 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "Progress.hh"

using SharpConstruct::Progress;
using SharpConstruct::Stepable;

Stepable::~Stepable()
{}

const std::string Stepable::Text() const
{
	return "";
}

Progress& Progress::Null()
{
	static Progress p;
	return p;
}

double Progress::Amount() const
{
	return amount_;
}

const std::string& Progress::Text() const
{
	return text_;
}

void Progress::Update( const double a )
{
	Update( a, text_ );
	
}
void Progress::Update( const double a, const std::string t )
{
	amount_ = a;
	text_ = t;
	ChangedSignal()( *this );
}

sigc::signal< void, const Progress& >& Progress::ChangedSignal()
{
	return changed_signal_;
}
